]> git.proxmox.com Git - mirror_qemu.git/blob - configure
tests/qtest: add support for callback to receive QMP events
[mirror_qemu.git] / configure
1 #!/bin/sh
2 #
3 # qemu configure script (c) 2003 Fabrice Bellard
4 #
5
6 # Unset some variables known to interfere with behavior of common tools,
7 # just as autoconf does. Unlike autoconf, we assume that unset exists.
8 unset CLICOLOR_FORCE GREP_OPTIONS BASH_ENV ENV MAIL MAILPATH CDPATH
9
10 # Don't allow CCACHE, if present, to use cached results of compile tests!
11 export CCACHE_RECACHE=yes
12
13 # make source path absolute
14 source_path=$(cd "$(dirname -- "$0")"; pwd)
15
16 if test "$PWD" = "$source_path"
17 then
18 echo "Using './build' as the directory for build output"
19
20 MARKER=build/auto-created-by-configure
21
22 if test -e build
23 then
24 if test -f $MARKER
25 then
26 rm -rf build
27 else
28 echo "ERROR: ./build dir already exists and was not previously created by configure"
29 exit 1
30 fi
31 fi
32
33 if ! mkdir build || ! touch $MARKER
34 then
35 echo "ERROR: Could not create ./build directory. Check the permissions on"
36 echo "your source directory, or try doing an out-of-tree build."
37 exit 1
38 fi
39
40 cat > GNUmakefile <<'EOF'
41 # This file is auto-generated by configure to support in-source tree
42 # 'make' command invocation
43
44 ifeq ($(MAKECMDGOALS),)
45 recurse: all
46 endif
47
48 .NOTPARALLEL: %
49 %: force
50 @echo 'changing dir to build for $(MAKE) "$(MAKECMDGOALS)"...'
51 @$(MAKE) -C build -f Makefile $(MAKECMDGOALS)
52 @if test "$(MAKECMDGOALS)" = "distclean" && \
53 test -e build/auto-created-by-configure ; \
54 then \
55 rm -rf build GNUmakefile ; \
56 fi
57 force: ;
58 .PHONY: force
59 GNUmakefile: ;
60
61 EOF
62 cd build
63 exec "$source_path/configure" "$@"
64 fi
65
66 # Temporary directory used for files created while
67 # configure runs. Since it is in the build directory
68 # we can safely blow away any previous version of it
69 # (and we need not jump through hoops to try to delete
70 # it when configure exits.)
71 TMPDIR1="config-temp"
72 rm -rf "${TMPDIR1}"
73 if ! mkdir -p "${TMPDIR1}"; then
74 echo "ERROR: failed to create temporary directory"
75 exit 1
76 fi
77
78 TMPB="qemu-conf"
79 TMPC="${TMPDIR1}/${TMPB}.c"
80 TMPO="${TMPDIR1}/${TMPB}.o"
81 TMPE="${TMPDIR1}/${TMPB}.exe"
82
83 rm -f config.log
84
85 # Print a helpful header at the top of config.log
86 echo "# QEMU configure log $(date)" >> config.log
87 printf "# Configured with:" >> config.log
88 # repeat the invocation to log and stdout for CI
89 invoke=$(printf " '%s'" "$0" "$@")
90 test -n "$GITLAB_CI" && echo "configuring with: $invoke"
91 { echo "$invoke"; echo; echo "#"; } >> config.log
92
93 quote_sh() {
94 printf "%s" "$1" | sed "s,','\\\\'',g; s,.*,'&',"
95 }
96
97 print_error() {
98 (echo
99 echo "ERROR: $1"
100 while test -n "$2"; do
101 echo " $2"
102 shift
103 done
104 echo) >&2
105 }
106
107 error_exit() {
108 print_error "$@"
109 exit 1
110 }
111
112 do_compiler() {
113 # Run the compiler, capturing its output to the log. First argument
114 # is compiler binary to execute.
115 compiler="$1"
116 shift
117 if test -n "$BASH_VERSION"; then eval '
118 echo >>config.log "
119 funcs: ${FUNCNAME[*]}
120 lines: ${BASH_LINENO[*]}"
121 '; fi
122 echo $compiler "$@" >> config.log
123 $compiler "$@" >> config.log 2>&1 || return $?
124 }
125
126 do_cc() {
127 do_compiler "$cc" $CPU_CFLAGS "$@"
128 }
129
130 compile_object() {
131 local_cflags="$1"
132 do_cc $CFLAGS $EXTRA_CFLAGS $local_cflags -c -o $TMPO $TMPC
133 }
134
135 compile_prog() {
136 local_cflags="$1"
137 local_ldflags="$2"
138 do_cc $CFLAGS $EXTRA_CFLAGS $local_cflags -o $TMPE $TMPC \
139 $LDFLAGS $EXTRA_LDFLAGS $local_ldflags
140 }
141
142 # symbolically link $1 to $2. Portable version of "ln -sf".
143 symlink() {
144 rm -rf "$2"
145 mkdir -p "$(dirname "$2")"
146 ln -s "$1" "$2"
147 }
148
149 # check whether a command is available to this shell (may be either an
150 # executable or a builtin)
151 has() {
152 type "$1" >/dev/null 2>&1
153 }
154
155 version_ge () {
156 local_ver1=$(expr "$1" : '\([0-9.]*\)' | tr . ' ')
157 local_ver2=$(echo "$2" | tr . ' ')
158 while true; do
159 set x $local_ver1
160 local_first=${2-0}
161 # 'shift 2' if $2 is set, or 'shift' if $2 is not set
162 shift ${2:+2}
163 local_ver1=$*
164 set x $local_ver2
165 # the second argument finished, the first must be greater or equal
166 test $# = 1 && return 0
167 test $local_first -lt $2 && return 1
168 test $local_first -gt $2 && return 0
169 shift ${2:+2}
170 local_ver2=$*
171 done
172 }
173
174 if printf %s\\n "$source_path" "$PWD" | grep -q "[[:space:]:]";
175 then
176 error_exit "main directory cannot contain spaces nor colons"
177 fi
178
179 # parse CC options first; some compiler tests are used to establish
180 # some defaults, based on the host environment
181
182 # default parameters
183 cpu=""
184 cross_compile="no"
185 cross_prefix=""
186 host_cc="cc"
187 EXTRA_CFLAGS=""
188 EXTRA_CXXFLAGS=""
189 EXTRA_OBJCFLAGS=""
190 EXTRA_LDFLAGS=""
191
192 # Default value for a variable defining feature "foo".
193 # * foo="no" feature will only be used if --enable-foo arg is given
194 # * foo="" feature will be searched for, and if found, will be used
195 # unless --disable-foo is given
196 # * foo="yes" this value will only be set by --enable-foo flag.
197 # feature will searched for,
198 # if not found, configure exits with error
199 #
200 # Always add --enable-foo and --disable-foo command line args.
201 # Distributions want to ensure that several features are compiled in, and it
202 # is impossible without a --enable-foo that exits if a feature is not found.
203 default_feature=""
204
205 for opt do
206 optarg=$(expr "x$opt" : 'x[^=]*=\(.*\)')
207 case "$opt" in
208 --cross-prefix=*) cross_prefix="$optarg"
209 cross_compile="yes"
210 ;;
211 --cc=*) CC="$optarg"
212 ;;
213 --cxx=*) CXX="$optarg"
214 ;;
215 --objcc=*) objcc="$optarg"
216 ;;
217 --cpu=*) cpu="$optarg"
218 ;;
219 --extra-cflags=*)
220 EXTRA_CFLAGS="$EXTRA_CFLAGS $optarg"
221 EXTRA_CXXFLAGS="$EXTRA_CXXFLAGS $optarg"
222 EXTRA_OBJCFLAGS="$EXTRA_OBJCFLAGS $optarg"
223 ;;
224 --extra-cxxflags=*) EXTRA_CXXFLAGS="$EXTRA_CXXFLAGS $optarg"
225 ;;
226 --extra-objcflags=*) EXTRA_OBJCFLAGS="$EXTRA_OBJCFLAGS $optarg"
227 ;;
228 --extra-ldflags=*) EXTRA_LDFLAGS="$EXTRA_LDFLAGS $optarg"
229 ;;
230 --cross-cc-*[!a-zA-Z0-9_-]*=*) error_exit "Passed bad --cross-cc-FOO option"
231 ;;
232 --cross-cc-cflags-*) cc_arch=${opt#--cross-cc-cflags-}; cc_arch=${cc_arch%%=*}
233 eval "cross_cc_cflags_${cc_arch}=\$optarg"
234 ;;
235 --cross-cc-*) cc_arch=${opt#--cross-cc-}; cc_arch=${cc_arch%%=*}
236 eval "cross_cc_${cc_arch}=\$optarg"
237 ;;
238 --cross-prefix-*[!a-zA-Z0-9_-]*=*) error_exit "Passed bad --cross-prefix-FOO option"
239 ;;
240 --cross-prefix-*) cc_arch=${opt#--cross-prefix-}; cc_arch=${cc_arch%%=*}
241 eval "cross_prefix_${cc_arch}=\$optarg"
242 ;;
243 --without-default-features) default_feature="no"
244 ;;
245 esac
246 done
247
248
249 if test -e "$source_path/.git"
250 then
251 git_submodules_action="update"
252 else
253 git_submodules_action="ignore"
254 fi
255
256 git_submodules="subprojects/keycodemapdb"
257 git="git"
258 debug_tcg="no"
259 docs="auto"
260 EXESUF=""
261 prefix="/usr/local"
262 qemu_suffix="qemu"
263 softmmu="yes"
264 linux_user=""
265 bsd_user=""
266 plugins="$default_feature"
267 ninja=""
268 python=
269 pypi="enabled"
270 bindir="bin"
271 skip_meson=no
272 vfio_user_server="disabled"
273 use_containers="yes"
274 gdb_bin=$(command -v "gdb-multiarch" || command -v "gdb")
275 gdb_arches=""
276 werror=""
277
278 # Don't accept a target_list environment variable.
279 unset target_list
280 unset target_list_exclude
281
282 # The following Meson options are handled manually (still they
283 # are included in the automatically generated help message)
284
285 # 1. Track which submodules are needed
286 fdt="auto"
287
288 # 2. Automatically enable/disable other options
289 tcg="auto"
290 cfi="false"
291
292 # 3. Need to check for -static-pie before Meson runs. Also,
293 # Meson has PIE as a boolean rather than enabled/disabled/auto.
294 pie=""
295 static="no"
296
297 # Preferred compiler:
298 # ${CC} (if set)
299 # ${cross_prefix}gcc (if cross-prefix specified)
300 # system compiler
301 if test -z "${CC}${cross_prefix}"; then
302 cc="$host_cc"
303 else
304 cc="${CC-${cross_prefix}gcc}"
305 fi
306
307 if test -z "${CXX}${cross_prefix}"; then
308 cxx="c++"
309 else
310 cxx="${CXX-${cross_prefix}g++}"
311 fi
312
313 # Preferred ObjC compiler:
314 # $objcc (if set, i.e. via --objcc option)
315 # ${cross_prefix}clang (if cross-prefix specified)
316 # clang (if available)
317 # $cc
318 if test -z "${objcc}${cross_prefix}"; then
319 if has clang; then
320 objcc=clang
321 else
322 objcc="$cc"
323 fi
324 else
325 objcc="${objcc-${cross_prefix}clang}"
326 fi
327
328 ar="${AR-${cross_prefix}ar}"
329 as="${AS-${cross_prefix}as}"
330 ccas="${CCAS-$cc}"
331 objcopy="${OBJCOPY-${cross_prefix}objcopy}"
332 ld="${LD-${cross_prefix}ld}"
333 ranlib="${RANLIB-${cross_prefix}ranlib}"
334 nm="${NM-${cross_prefix}nm}"
335 smbd="$SMBD"
336 strip="${STRIP-${cross_prefix}strip}"
337 widl="${WIDL-${cross_prefix}widl}"
338 windres="${WINDRES-${cross_prefix}windres}"
339 windmc="${WINDMC-${cross_prefix}windmc}"
340 pkg_config="${PKG_CONFIG-${cross_prefix}pkg-config}"
341 sdl2_config="${SDL2_CONFIG-${cross_prefix}sdl2-config}"
342
343 check_define() {
344 cat > $TMPC <<EOF
345 #if !defined($1)
346 #error $1 not defined
347 #endif
348 int main(void) { return 0; }
349 EOF
350 compile_object
351 }
352
353 write_c_skeleton() {
354 cat > $TMPC <<EOF
355 int main(void) { return 0; }
356 EOF
357 }
358
359 if check_define __linux__ ; then
360 targetos=linux
361 elif check_define _WIN32 ; then
362 targetos=windows
363 elif check_define __OpenBSD__ ; then
364 targetos=openbsd
365 elif check_define __sun__ ; then
366 targetos=sunos
367 elif check_define __HAIKU__ ; then
368 targetos=haiku
369 elif check_define __FreeBSD__ ; then
370 targetos=freebsd
371 elif check_define __FreeBSD_kernel__ && check_define __GLIBC__; then
372 targetos=gnu/kfreebsd
373 elif check_define __DragonFly__ ; then
374 targetos=dragonfly
375 elif check_define __NetBSD__; then
376 targetos=netbsd
377 elif check_define __APPLE__; then
378 targetos=darwin
379 else
380 # This is a fatal error, but don't report it yet, because we
381 # might be going to just print the --help text, or it might
382 # be the result of a missing compiler.
383 targetos=bogus
384 fi
385
386 # OS specific
387
388 mingw32="no"
389 bsd="no"
390 linux="no"
391 solaris="no"
392 case $targetos in
393 windows)
394 mingw32="yes"
395 plugins="no"
396 pie="no"
397 ;;
398 gnu/kfreebsd)
399 bsd="yes"
400 ;;
401 freebsd)
402 bsd="yes"
403 # needed for kinfo_getvmmap(3) in libutil.h
404 ;;
405 dragonfly)
406 bsd="yes"
407 ;;
408 netbsd)
409 bsd="yes"
410 ;;
411 openbsd)
412 bsd="yes"
413 ;;
414 darwin)
415 bsd="yes"
416 darwin="yes"
417 ;;
418 sunos)
419 solaris="yes"
420 ;;
421 haiku)
422 pie="no"
423 ;;
424 linux)
425 linux="yes"
426 ;;
427 esac
428
429 if test ! -z "$cpu" ; then
430 # command line argument
431 :
432 elif check_define __i386__ ; then
433 cpu="i386"
434 elif check_define __x86_64__ ; then
435 if check_define __ILP32__ ; then
436 cpu="x32"
437 else
438 cpu="x86_64"
439 fi
440 elif check_define __sparc__ ; then
441 if check_define __arch64__ ; then
442 cpu="sparc64"
443 else
444 cpu="sparc"
445 fi
446 elif check_define _ARCH_PPC ; then
447 if check_define _ARCH_PPC64 ; then
448 if check_define _LITTLE_ENDIAN ; then
449 cpu="ppc64le"
450 else
451 cpu="ppc64"
452 fi
453 else
454 cpu="ppc"
455 fi
456 elif check_define __mips__ ; then
457 cpu="mips"
458 elif check_define __s390__ ; then
459 if check_define __s390x__ ; then
460 cpu="s390x"
461 else
462 cpu="s390"
463 fi
464 elif check_define __riscv ; then
465 cpu="riscv"
466 elif check_define __arm__ ; then
467 cpu="arm"
468 elif check_define __aarch64__ ; then
469 cpu="aarch64"
470 elif check_define __loongarch64 ; then
471 cpu="loongarch64"
472 else
473 # Using uname is really broken, but it is just a fallback for architectures
474 # that are going to use TCI anyway
475 cpu=$(uname -m)
476 echo "WARNING: unrecognized host CPU, proceeding with 'uname -m' output '$cpu'"
477 fi
478
479 # Normalise host CPU name and set multilib cflags. The canonicalization
480 # isn't really necessary, because the architectures that we check for
481 # should not hit the 'uname -m' case, but better safe than sorry.
482 # Note that this case should only have supported host CPUs, not guests.
483 case "$cpu" in
484 armv*b|armv*l|arm)
485 cpu="arm" ;;
486
487 i386|i486|i586|i686)
488 cpu="i386"
489 CPU_CFLAGS="-m32" ;;
490 x32)
491 cpu="x86_64"
492 CPU_CFLAGS="-mx32" ;;
493 x86_64|amd64)
494 cpu="x86_64"
495 # ??? Only extremely old AMD cpus do not have cmpxchg16b.
496 # If we truly care, we should simply detect this case at
497 # runtime and generate the fallback to serial emulation.
498 CPU_CFLAGS="-m64 -mcx16" ;;
499
500 mips*)
501 cpu="mips" ;;
502
503 ppc)
504 CPU_CFLAGS="-m32" ;;
505 ppc64)
506 CPU_CFLAGS="-m64 -mbig-endian" ;;
507 ppc64le)
508 cpu="ppc64"
509 CPU_CFLAGS="-m64 -mlittle-endian" ;;
510
511 s390)
512 CPU_CFLAGS="-m31" ;;
513 s390x)
514 CPU_CFLAGS="-m64" ;;
515
516 sparc|sun4[cdmuv])
517 cpu="sparc"
518 CPU_CFLAGS="-m32 -mv8plus -mcpu=ultrasparc" ;;
519 sparc64)
520 CPU_CFLAGS="-m64 -mcpu=ultrasparc" ;;
521 esac
522
523 check_py_version() {
524 # We require python >= 3.7.
525 # NB: a True python conditional creates a non-zero return code (Failure)
526 "$1" -c 'import sys; sys.exit(sys.version_info < (3,7))'
527 }
528
529 first_python=
530 if test -z "${PYTHON}"; then
531 # A bare 'python' is traditionally python 2.x, but some distros
532 # have it as python 3.x, so check in both places.
533 for binary in python3 python python3.11 python3.10 python3.9 python3.8 python3.7; do
534 if has "$binary"; then
535 python=$(command -v "$binary")
536 if check_py_version "$python"; then
537 # This one is good.
538 first_python=
539 break
540 else
541 first_python=$python
542 fi
543 fi
544 done
545 else
546 # Same as above, but only check the environment variable.
547 has "${PYTHON}" || error_exit "The PYTHON environment variable does not point to an executable"
548 python=$(command -v "$PYTHON")
549 if check_py_version "$python"; then
550 # This one is good.
551 first_python=
552 else
553 first_python=$first_python
554 fi
555 fi
556
557 # Check for ancillary tools used in testing
558 genisoimage=
559 for binary in genisoimage mkisofs
560 do
561 if has $binary
562 then
563 genisoimage=$(command -v "$binary")
564 break
565 fi
566 done
567
568 if test "$mingw32" = "yes" ; then
569 EXESUF=".exe"
570 prefix="/qemu"
571 bindir=""
572 qemu_suffix=""
573 fi
574
575 meson_option_build_array() {
576 printf '['
577 (if test "$targetos" = windows; then
578 IFS=\;
579 else
580 IFS=:
581 fi
582 for e in $1; do
583 printf '"""'
584 # backslash escape any '\' and '"' characters
585 printf "%s" "$e" | sed -e 's/\([\"]\)/\\\1/g'
586 printf '""",'
587 done)
588 printf ']\n'
589 }
590
591 . "$source_path/scripts/meson-buildoptions.sh"
592
593 meson_options=
594 meson_option_add() {
595 meson_options="$meson_options $(quote_sh "$1")"
596 }
597 meson_option_parse() {
598 meson_options="$meson_options $(_meson_option_parse "$@")"
599 if test $? -eq 1; then
600 echo "ERROR: unknown option $1"
601 echo "Try '$0 --help' for more information"
602 exit 1
603 fi
604 }
605
606 for opt do
607 optarg=$(expr "x$opt" : 'x[^=]*=\(.*\)')
608 case "$opt" in
609 --help|-h) show_help=yes
610 ;;
611 --version|-V) exec cat "$source_path/VERSION"
612 ;;
613 --prefix=*) prefix="$optarg"
614 ;;
615 --cross-prefix=*)
616 ;;
617 --cc=*)
618 ;;
619 --host-cc=*) host_cc="$optarg"
620 ;;
621 --cxx=*)
622 ;;
623 --objcc=*)
624 ;;
625 --make=*)
626 ;;
627 --install=*)
628 ;;
629 --python=*) python="$optarg"
630 ;;
631 --skip-meson) skip_meson=yes
632 ;;
633 --ninja=*) ninja="$optarg"
634 ;;
635 --smbd=*) smbd="$optarg"
636 ;;
637 --extra-cflags=*)
638 ;;
639 --extra-cxxflags=*)
640 ;;
641 --extra-objcflags=*)
642 ;;
643 --extra-ldflags=*)
644 ;;
645 --cross-cc-*)
646 ;;
647 --cross-prefix-*)
648 ;;
649 --enable-docs) docs=enabled
650 ;;
651 --disable-docs) docs=disabled
652 ;;
653 --cpu=*)
654 ;;
655 --target-list=*) target_list="$optarg"
656 if test "$target_list_exclude"; then
657 error_exit "Can't mix --target-list with --target-list-exclude"
658 fi
659 ;;
660 --target-list-exclude=*) target_list_exclude="$optarg"
661 if test "$target_list"; then
662 error_exit "Can't mix --target-list-exclude with --target-list"
663 fi
664 ;;
665 --with-default-devices) meson_option_add -Ddefault_devices=true
666 ;;
667 --without-default-devices) meson_option_add -Ddefault_devices=false
668 ;;
669 --with-devices-*[!a-zA-Z0-9_-]*=*) error_exit "Passed bad --with-devices-FOO option"
670 ;;
671 --with-devices-*) device_arch=${opt#--with-devices-};
672 device_arch=${device_arch%%=*}
673 cf=$source_path/configs/devices/$device_arch-softmmu/$optarg.mak
674 if test -f "$cf"; then
675 device_archs="$device_archs $device_arch"
676 eval "devices_${device_arch}=\$optarg"
677 else
678 error_exit "File $cf does not exist"
679 fi
680 ;;
681 --without-default-features) # processed above
682 ;;
683 --static) static="yes"
684 ;;
685 --bindir=*) bindir="$optarg"
686 ;;
687 --with-suffix=*) qemu_suffix="$optarg"
688 ;;
689 --host=*|--build=*|\
690 --disable-dependency-tracking|\
691 --sbindir=*|--sharedstatedir=*|\
692 --oldincludedir=*|--datarootdir=*|--infodir=*|\
693 --htmldir=*|--dvidir=*|--pdfdir=*|--psdir=*)
694 # These switches are silently ignored, for compatibility with
695 # autoconf-generated configure scripts. This allows QEMU's
696 # configure to be used by RPM and similar macros that set
697 # lots of directory switches by default.
698 ;;
699 --enable-debug-tcg) debug_tcg="yes"
700 ;;
701 --disable-debug-tcg) debug_tcg="no"
702 ;;
703 --enable-debug)
704 # Enable debugging options that aren't excessively noisy
705 debug_tcg="yes"
706 meson_option_parse --enable-debug-graph-lock ""
707 meson_option_parse --enable-debug-mutex ""
708 meson_option_add -Doptimization=0
709 ;;
710 --disable-tcg) tcg="disabled"
711 plugins="no"
712 ;;
713 --enable-tcg) tcg="enabled"
714 ;;
715 --disable-system) softmmu="no"
716 ;;
717 --enable-system) softmmu="yes"
718 ;;
719 --disable-user)
720 linux_user="no" ;
721 bsd_user="no" ;
722 ;;
723 --enable-user) ;;
724 --disable-linux-user) linux_user="no"
725 ;;
726 --enable-linux-user) linux_user="yes"
727 ;;
728 --disable-bsd-user) bsd_user="no"
729 ;;
730 --enable-bsd-user) bsd_user="yes"
731 ;;
732 --enable-pie) pie="yes"
733 ;;
734 --disable-pie) pie="no"
735 ;;
736 --enable-werror) werror="yes"
737 ;;
738 --disable-werror) werror="no"
739 ;;
740 --enable-cfi)
741 cfi="true";
742 meson_option_add -Db_lto=true
743 ;;
744 --disable-cfi) cfi="false"
745 ;;
746 --disable-fdt) fdt="disabled"
747 ;;
748 --enable-fdt) fdt="enabled"
749 ;;
750 --enable-fdt=git) fdt="internal"
751 ;;
752 --enable-fdt=*) fdt="$optarg"
753 ;;
754 --with-git=*) git="$optarg"
755 ;;
756 --with-git-submodules=*)
757 git_submodules_action="$optarg"
758 ;;
759 --disable-pypi) pypi="disabled"
760 ;;
761 --enable-pypi) pypi="enabled"
762 ;;
763 --enable-plugins) if test "$mingw32" = "yes"; then
764 error_exit "TCG plugins not currently supported on Windows platforms"
765 else
766 plugins="yes"
767 fi
768 ;;
769 --disable-plugins) plugins="no"
770 ;;
771 --enable-containers) use_containers="yes"
772 ;;
773 --disable-containers) use_containers="no"
774 ;;
775 --gdb=*) gdb_bin="$optarg"
776 ;;
777 --enable-vfio-user-server) vfio_user_server="enabled"
778 ;;
779 --disable-vfio-user-server) vfio_user_server="disabled"
780 ;;
781 # everything else has the same name in configure and meson
782 --*) meson_option_parse "$opt" "$optarg"
783 ;;
784 esac
785 done
786
787 # test for any invalid configuration combinations
788 if test "$plugins" = "yes" -a "$tcg" = "disabled"; then
789 error_exit "Can't enable plugins on non-TCG builds"
790 fi
791
792 case $git_submodules_action in
793 update|validate)
794 if test ! -e "$source_path/.git"; then
795 echo "ERROR: cannot $git_submodules_action git submodules without .git"
796 exit 1
797 fi
798 ;;
799 ignore)
800 if ! test -f "$source_path/subprojects/keycodemapdb/README"
801 then
802 echo
803 echo "ERROR: missing GIT submodules"
804 echo
805 if test -e "$source_path/.git"; then
806 echo "--with-git-submodules=ignore specified but submodules were not"
807 echo "checked out. Please initialize and update submodules."
808 else
809 echo "This is not a GIT checkout but module content appears to"
810 echo "be missing. Do not use 'git archive' or GitHub download links"
811 echo "to acquire QEMU source archives. Non-GIT builds are only"
812 echo "supported with source archives linked from:"
813 echo
814 echo " https://www.qemu.org/download/#source"
815 echo
816 echo "Developers working with GIT can use scripts/archive-source.sh"
817 echo "if they need to create valid source archives."
818 fi
819 echo
820 exit 1
821 fi
822 ;;
823 *)
824 echo "ERROR: invalid --with-git-submodules= value '$git_submodules_action'"
825 exit 1
826 ;;
827 esac
828
829 default_target_list=""
830 mak_wilds=""
831
832 if [ "$linux_user" != no ]; then
833 if [ "$targetos" = linux ] && [ -d "$source_path/linux-user/include/host/$cpu" ]; then
834 linux_user=yes
835 elif [ "$linux_user" = yes ]; then
836 error_exit "linux-user not supported on this architecture"
837 fi
838 fi
839 if [ "$bsd_user" != no ]; then
840 if [ "$bsd_user" = "" ]; then
841 test $targetos = freebsd && bsd_user=yes
842 fi
843 if [ "$bsd_user" = yes ] && ! [ -d "$source_path/bsd-user/$targetos" ]; then
844 error_exit "bsd-user not supported on this host OS"
845 fi
846 fi
847 if [ "$softmmu" = "yes" ]; then
848 mak_wilds="${mak_wilds} $source_path/configs/targets/*-softmmu.mak"
849 fi
850 if [ "$linux_user" = "yes" ]; then
851 mak_wilds="${mak_wilds} $source_path/configs/targets/*-linux-user.mak"
852 fi
853 if [ "$bsd_user" = "yes" ]; then
854 mak_wilds="${mak_wilds} $source_path/configs/targets/*-bsd-user.mak"
855 fi
856
857 for config in $mak_wilds; do
858 target="$(basename "$config" .mak)"
859 if echo "$target_list_exclude" | grep -vq "$target"; then
860 default_target_list="${default_target_list} $target"
861 fi
862 done
863
864 if test x"$show_help" = x"yes" ; then
865 cat << EOF
866
867 Usage: configure [options]
868 Options: [defaults in brackets after descriptions]
869
870 Standard options:
871 --help print this message
872 --prefix=PREFIX install in PREFIX [$prefix]
873 --target-list=LIST set target list (default: build all)
874 $(echo Available targets: $default_target_list | \
875 fold -s -w 53 | sed -e 's/^/ /')
876 --target-list-exclude=LIST exclude a set of targets from the default target-list
877
878 Advanced options (experts only):
879 --cross-prefix=PREFIX use PREFIX for compile tools, PREFIX can be blank [$cross_prefix]
880 --cc=CC use C compiler CC [$cc]
881 --host-cc=CC use C compiler CC [$host_cc] for code run at
882 build time
883 --cxx=CXX use C++ compiler CXX [$cxx]
884 --objcc=OBJCC use Objective-C compiler OBJCC [$objcc]
885 --extra-cflags=CFLAGS append extra C compiler flags CFLAGS
886 --extra-cxxflags=CXXFLAGS append extra C++ compiler flags CXXFLAGS
887 --extra-objcflags=OBJCFLAGS append extra Objective C compiler flags OBJCFLAGS
888 --extra-ldflags=LDFLAGS append extra linker flags LDFLAGS
889 --cross-cc-ARCH=CC use compiler when building ARCH guest test cases
890 --cross-cc-cflags-ARCH= use compiler flags when building ARCH guest tests
891 --cross-prefix-ARCH=PREFIX cross compiler prefix when building ARCH guest test cases
892 --python=PYTHON use specified python [$python]
893 --ninja=NINJA use specified ninja [$ninja]
894 --smbd=SMBD use specified smbd [$smbd]
895 --with-git=GIT use specified git [$git]
896 --with-git-submodules=update update git submodules (default if .git dir exists)
897 --with-git-submodules=validate fail if git submodules are not up to date
898 --with-git-submodules=ignore do not update or check git submodules (default if no .git dir)
899 --static enable static build [$static]
900 --bindir=PATH install binaries in PATH
901 --with-suffix=SUFFIX suffix for QEMU data inside datadir/libdir/sysconfdir/docdir [$qemu_suffix]
902 --without-default-features default all --enable-* options to "disabled"
903 --without-default-devices do not include any device that is not needed to
904 start the emulator (only use if you are including
905 desired devices in configs/devices/)
906 --with-devices-ARCH=NAME override default configs/devices
907 --enable-debug enable common debug build options
908 --disable-werror disable compilation abort on warning
909 --cpu=CPU Build for host CPU [$cpu]
910 --enable-plugins
911 enable plugins via shared library loading
912 --disable-containers don't use containers for cross-building
913 --gdb=GDB-path gdb to use for gdbstub tests [$gdb_bin]
914 EOF
915 meson_options_help
916 cat << EOF
917 system all system emulation targets
918 user supported user emulation targets
919 linux-user all linux usermode emulation targets
920 bsd-user all BSD usermode emulation targets
921 pie Position Independent Executables
922 debug-tcg TCG debugging (default is disabled)
923
924 NOTE: The object files are built at the place where configure is launched
925 EOF
926 exit 0
927 fi
928
929 # Remove old dependency files to make sure that they get properly regenerated
930 rm -f ./*/config-devices.mak.d
931
932 if test -z "$python"
933 then
934 # If first_python is set, there was a binary somewhere even though
935 # it was not suitable. Use it for the error message.
936 if test -n "$first_python"; then
937 error_exit "Cannot use '$first_python', Python >= 3.7 is required." \
938 "Use --python=/path/to/python to specify a supported Python."
939 else
940 error_exit "Python not found. Use --python=/path/to/python"
941 fi
942 fi
943
944 if ! check_py_version "$python"; then
945 error_exit "Cannot use '$python', Python >= 3.7 is required." \
946 "Use --python=/path/to/python to specify a supported Python." \
947 "Maybe try:" \
948 " openSUSE Leap 15.3+: zypper install python39" \
949 " CentOS 8: dnf install python38"
950 fi
951
952 # Resolve PATH
953 python="$(command -v "$python")"
954
955 # Create a Python virtual environment using our configured python.
956 # The stdout of this script will be the location of a symlink that
957 # points to the configured Python.
958 # Entry point scripts for pip, meson, and sphinx are generated if those
959 # packages are present.
960
961 # Defaults assumed for now:
962 # - venv is cleared if it exists already;
963 # - venv is allowed to use system packages;
964 # - all setup can be performed offline;
965 # - missing packages may be fetched from PyPI,
966 # unless --disable-pypi is passed.
967 # - pip is not installed into the venv when possible,
968 # but ensurepip is called as a fallback when necessary.
969
970 echo "python determined to be '$python'"
971 echo "python version: $($python --version)"
972
973 python="$($python -B "${source_path}/python/scripts/mkvenv.py" create pyvenv)"
974 if test "$?" -ne 0 ; then
975 error_exit "python venv creation failed"
976 fi
977
978 # Suppress writing compiled files
979 python="$python -B"
980 mkvenv="$python ${source_path}/python/scripts/mkvenv.py"
981
982 mkvenv_flags=""
983 if test "$pypi" = "enabled" ; then
984 mkvenv_flags="--online"
985 fi
986
987 if ! $mkvenv ensure \
988 $mkvenv_flags \
989 --dir "${source_path}/python/wheels" \
990 --diagnose "meson" \
991 "meson>=0.63.0" ;
992 then
993 exit 1
994 fi
995
996 # At this point, we expect Meson to be installed and available.
997 # We expect mkvenv or pip to have created pyvenv/bin/meson for us.
998 # We ignore PATH completely here: we want to use the venv's Meson
999 # *exclusively*.
1000
1001 meson="$(cd pyvenv/bin; pwd)/meson"
1002
1003 # Conditionally ensure Sphinx is installed.
1004
1005 mkvenv_flags=""
1006 if test "$pypi" = "enabled" -a "$docs" = "enabled" ; then
1007 mkvenv_flags="--online"
1008 fi
1009
1010 if test "$docs" != "disabled" ; then
1011 if ! $mkvenv ensure \
1012 $mkvenv_flags \
1013 --diagnose "sphinx-build" \
1014 "sphinx>=1.6.0" "sphinx-rtd-theme>=0.5.0";
1015 then
1016 if test "$docs" = "enabled" ; then
1017 exit 1
1018 fi
1019 echo "Sphinx not found/usable, disabling docs."
1020 docs=disabled
1021 else
1022 docs=enabled
1023 fi
1024 fi
1025
1026 # Probe for ninja
1027
1028 if test -z "$ninja"; then
1029 for c in ninja ninja-build samu; do
1030 if has $c; then
1031 ninja=$(command -v "$c")
1032 break
1033 fi
1034 done
1035 if test -z "$ninja"; then
1036 error_exit "Cannot find Ninja"
1037 fi
1038 fi
1039
1040 # Consult white-list to determine whether to enable werror
1041 # by default. Only enable by default for git builds
1042 if test -z "$werror" ; then
1043 if test "$git_submodules_action" != "ignore" && \
1044 { test "$linux" = "yes" || test "$mingw32" = "yes"; }; then
1045 werror="yes"
1046 else
1047 werror="no"
1048 fi
1049 fi
1050
1051 if test "$targetos" = "bogus"; then
1052 # Now that we know that we're not printing the help and that
1053 # the compiler works (so the results of the check_defines we used
1054 # to identify the OS are reliable), if we didn't recognize the
1055 # host OS we should stop now.
1056 error_exit "Unrecognized host OS (uname -s reports '$(uname -s)')"
1057 fi
1058
1059 if test "$static" = "yes" ; then
1060 if test "$plugins" = "yes"; then
1061 error_exit "static and plugins are mutually incompatible"
1062 else
1063 plugins="no"
1064 fi
1065 fi
1066 test "$plugins" = "" && plugins=yes
1067
1068 cat > $TMPC << EOF
1069
1070 #ifdef __linux__
1071 # define THREAD __thread
1072 #else
1073 # define THREAD
1074 #endif
1075 static THREAD int tls_var;
1076 int main(void) { return tls_var; }
1077 EOF
1078
1079 if test "$static" = "yes"; then
1080 if test "$pie" != "no" && compile_prog "-Werror -fPIE -DPIE" "-static-pie"; then
1081 pie="yes"
1082 elif test "$pie" = "yes"; then
1083 error_exit "-static-pie not available due to missing toolchain support"
1084 else
1085 pie="no"
1086 fi
1087 elif test "$pie" != "no"; then
1088 if compile_prog "-Werror -fPIE -DPIE" "-pie"; then
1089 pie="yes"
1090 elif test "$pie" = "yes"; then
1091 error_exit "PIE not available due to missing toolchain support"
1092 else
1093 echo "Disabling PIE due to missing toolchain support"
1094 pie="no"
1095 fi
1096 fi
1097
1098 ##########################################
1099
1100 if test -z "${target_list+xxx}" ; then
1101 default_targets=yes
1102 for target in $default_target_list; do
1103 target_list="$target_list $target"
1104 done
1105 target_list="${target_list# }"
1106 else
1107 default_targets=no
1108 target_list=$(echo "$target_list" | sed -e 's/,/ /g')
1109 for target in $target_list; do
1110 # Check that we recognised the target name; this allows a more
1111 # friendly error message than if we let it fall through.
1112 case " $default_target_list " in
1113 *" $target "*)
1114 ;;
1115 *)
1116 error_exit "Unknown target name '$target'"
1117 ;;
1118 esac
1119 done
1120 fi
1121
1122 # see if system emulation was really requested
1123 case " $target_list " in
1124 *"-softmmu "*) softmmu=yes
1125 ;;
1126 *) softmmu=no
1127 ;;
1128 esac
1129
1130 if test "$tcg" = "auto"; then
1131 if test -z "$target_list"; then
1132 tcg="disabled"
1133 else
1134 tcg="enabled"
1135 fi
1136 fi
1137
1138 if test "$tcg" = "enabled"; then
1139 git_submodules="$git_submodules tests/fp/berkeley-testfloat-3"
1140 git_submodules="$git_submodules tests/fp/berkeley-softfloat-3"
1141 fi
1142
1143 ##########################################
1144 # big/little endian test
1145 cat > $TMPC << EOF
1146 #if defined(__BYTE_ORDER__) && __BYTE_ORDER__ == __ORDER_LITTLE_ENDIAN__
1147 # error LITTLE
1148 #endif
1149 int main(void) { return 0; }
1150 EOF
1151
1152 if ! compile_prog ; then
1153 bigendian="no"
1154 else
1155 cat > $TMPC << EOF
1156 #if defined(__BYTE_ORDER__) && __BYTE_ORDER__ == __ORDER_BIG_ENDIAN__
1157 # error BIG
1158 #endif
1159 int main(void) { return 0; }
1160 EOF
1161
1162 if ! compile_prog ; then
1163 bigendian="yes"
1164 else
1165 echo big/little test failed
1166 exit 1
1167 fi
1168 fi
1169
1170 ##########################################
1171 # fdt probe
1172
1173 case "$fdt" in
1174 auto | enabled | internal)
1175 # Simpler to always update submodule, even if not needed.
1176 git_submodules="${git_submodules} subprojects/dtc"
1177 ;;
1178 esac
1179
1180 ########################################
1181 # check if ccache is interfering with
1182 # semantic analysis of macros
1183
1184 unset CCACHE_CPP2
1185 ccache_cpp2=no
1186 cat > $TMPC << EOF
1187 static const int Z = 1;
1188 #define fn() ({ Z; })
1189 #define TAUT(X) ((X) == Z)
1190 #define PAREN(X, Y) (X == Y)
1191 #define ID(X) (X)
1192 int main(void)
1193 {
1194 int x = 0, y = 0;
1195 x = ID(x);
1196 x = fn();
1197 fn();
1198 if (PAREN(x, y)) return 0;
1199 if (TAUT(Z)) return 0;
1200 return 0;
1201 }
1202 EOF
1203
1204 if ! compile_object "-Werror"; then
1205 ccache_cpp2=yes
1206 fi
1207
1208 ##########################################
1209 # functions to probe cross compilers
1210
1211 container="no"
1212 runc=""
1213 if test $use_containers = "yes" && (has "docker" || has "podman"); then
1214 case $($python "$source_path"/tests/docker/docker.py probe) in
1215 *docker) container=docker ;;
1216 podman) container=podman ;;
1217 no) container=no ;;
1218 esac
1219 if test "$container" != "no"; then
1220 docker_py="$python $source_path/tests/docker/docker.py --engine $container"
1221 runc=$($python "$source_path"/tests/docker/docker.py probe)
1222 fi
1223 fi
1224
1225 # cross compilers defaults, can be overridden with --cross-cc-ARCH
1226 : ${cross_prefix_aarch64="aarch64-linux-gnu-"}
1227 : ${cross_prefix_aarch64_be="$cross_prefix_aarch64"}
1228 : ${cross_prefix_alpha="alpha-linux-gnu-"}
1229 : ${cross_prefix_arm="arm-linux-gnueabihf-"}
1230 : ${cross_prefix_armeb="$cross_prefix_arm"}
1231 : ${cross_prefix_hexagon="hexagon-unknown-linux-musl-"}
1232 : ${cross_prefix_loongarch64="loongarch64-unknown-linux-gnu-"}
1233 : ${cross_prefix_hppa="hppa-linux-gnu-"}
1234 : ${cross_prefix_i386="i686-linux-gnu-"}
1235 : ${cross_prefix_m68k="m68k-linux-gnu-"}
1236 : ${cross_prefix_microblaze="microblaze-linux-musl-"}
1237 : ${cross_prefix_mips64el="mips64el-linux-gnuabi64-"}
1238 : ${cross_prefix_mips64="mips64-linux-gnuabi64-"}
1239 : ${cross_prefix_mipsel="mipsel-linux-gnu-"}
1240 : ${cross_prefix_mips="mips-linux-gnu-"}
1241 : ${cross_prefix_nios2="nios2-linux-gnu-"}
1242 : ${cross_prefix_ppc="powerpc-linux-gnu-"}
1243 : ${cross_prefix_ppc64="powerpc64-linux-gnu-"}
1244 : ${cross_prefix_ppc64le="$cross_prefix_ppc64"}
1245 : ${cross_prefix_riscv64="riscv64-linux-gnu-"}
1246 : ${cross_prefix_s390x="s390x-linux-gnu-"}
1247 : ${cross_prefix_sh4="sh4-linux-gnu-"}
1248 : ${cross_prefix_sparc64="sparc64-linux-gnu-"}
1249 : ${cross_prefix_sparc="$cross_prefix_sparc64"}
1250 : ${cross_prefix_x86_64="x86_64-linux-gnu-"}
1251
1252 : ${cross_cc_aarch64_be="$cross_cc_aarch64"}
1253 : ${cross_cc_cflags_aarch64_be="-mbig-endian"}
1254 : ${cross_cc_armeb="$cross_cc_arm"}
1255 : ${cross_cc_cflags_armeb="-mbig-endian"}
1256 : ${cross_cc_hexagon="hexagon-unknown-linux-musl-clang"}
1257 : ${cross_cc_cflags_hexagon="-mv73 -O2 -static"}
1258 : ${cross_cc_cflags_i386="-m32"}
1259 : ${cross_cc_cflags_ppc="-m32 -mbig-endian"}
1260 : ${cross_cc_cflags_ppc64="-m64 -mbig-endian"}
1261 : ${cross_cc_ppc64le="$cross_cc_ppc64"}
1262 : ${cross_cc_cflags_ppc64le="-m64 -mlittle-endian"}
1263 : ${cross_cc_cflags_sparc64="-m64 -mcpu=ultrasparc"}
1264 : ${cross_cc_sparc="$cross_cc_sparc64"}
1265 : ${cross_cc_cflags_sparc="-m32 -mcpu=supersparc"}
1266 : ${cross_cc_cflags_x86_64="-m64"}
1267
1268 compute_target_variable() {
1269 eval "$2="
1270 if eval test -n "\"\${cross_prefix_$1}\""; then
1271 if eval has "\"\${cross_prefix_$1}\$3\""; then
1272 eval "$2=\"\${cross_prefix_$1}\$3\""
1273 fi
1274 fi
1275 }
1276
1277 have_target() {
1278 for i; do
1279 case " $target_list " in
1280 *" $i "*) return 0;;
1281 *) ;;
1282 esac
1283 done
1284 return 1
1285 }
1286
1287 # probe_target_compiler TARGET
1288 #
1289 # Look for a compiler for the given target, either native or cross.
1290 # Set variables target_* if a compiler is found, and container_cross_*
1291 # if a Docker-based cross-compiler image is known for the target.
1292 # Set got_cross_cc to yes/no depending on whether a non-container-based
1293 # compiler was found.
1294 #
1295 # If TARGET is a user-mode emulation target, also set build_static to
1296 # "y" if static linking is possible.
1297 #
1298 probe_target_compiler() {
1299 # reset all output variables
1300 got_cross_cc=no
1301 container_image=
1302 container_hosts=
1303 container_cross_cc=
1304 container_cross_ar=
1305 container_cross_as=
1306 container_cross_ld=
1307 container_cross_nm=
1308 container_cross_objcopy=
1309 container_cross_ranlib=
1310 container_cross_strip=
1311
1312 target_arch=${1%%-*}
1313 case $target_arch in
1314 aarch64) container_hosts="x86_64 aarch64" ;;
1315 alpha) container_hosts=x86_64 ;;
1316 arm) container_hosts="x86_64 aarch64" ;;
1317 cris) container_hosts=x86_64 ;;
1318 hexagon) container_hosts=x86_64 ;;
1319 hppa) container_hosts=x86_64 ;;
1320 i386) container_hosts=x86_64 ;;
1321 loongarch64) container_hosts=x86_64 ;;
1322 m68k) container_hosts=x86_64 ;;
1323 microblaze) container_hosts=x86_64 ;;
1324 mips64el) container_hosts=x86_64 ;;
1325 mips64) container_hosts=x86_64 ;;
1326 mipsel) container_hosts=x86_64 ;;
1327 mips) container_hosts=x86_64 ;;
1328 nios2) container_hosts=x86_64 ;;
1329 ppc) container_hosts=x86_64 ;;
1330 ppc64|ppc64le) container_hosts=x86_64 ;;
1331 riscv64) container_hosts=x86_64 ;;
1332 s390x) container_hosts=x86_64 ;;
1333 sh4) container_hosts=x86_64 ;;
1334 sparc64) container_hosts=x86_64 ;;
1335 tricore) container_hosts=x86_64 ;;
1336 x86_64) container_hosts="aarch64 ppc64el x86_64" ;;
1337 xtensa*) container_hosts=x86_64 ;;
1338 esac
1339
1340 for host in $container_hosts; do
1341 test "$container" != no || continue
1342 test "$host" = "$cpu" || continue
1343 case $target_arch in
1344 aarch64)
1345 # We don't have any bigendian build tools so we only use this for AArch64
1346 container_image=debian-arm64-cross
1347 container_cross_prefix=aarch64-linux-gnu-
1348 container_cross_cc=${container_cross_prefix}gcc-10
1349 ;;
1350 alpha)
1351 container_image=debian-alpha-cross
1352 container_cross_prefix=alpha-linux-gnu-
1353 ;;
1354 arm)
1355 # We don't have any bigendian build tools so we only use this for ARM
1356 container_image=debian-armhf-cross
1357 container_cross_prefix=arm-linux-gnueabihf-
1358 ;;
1359 cris)
1360 container_image=fedora-cris-cross
1361 container_cross_prefix=cris-linux-gnu-
1362 ;;
1363 hexagon)
1364 container_image=debian-hexagon-cross
1365 container_cross_prefix=hexagon-unknown-linux-musl-
1366 container_cross_cc=${container_cross_prefix}clang
1367 ;;
1368 hppa)
1369 container_image=debian-hppa-cross
1370 container_cross_prefix=hppa-linux-gnu-
1371 ;;
1372 i386)
1373 container_image=fedora-i386-cross
1374 container_cross_prefix=
1375 ;;
1376 loongarch64)
1377 container_image=debian-loongarch-cross
1378 container_cross_prefix=loongarch64-unknown-linux-gnu-
1379 ;;
1380 m68k)
1381 container_image=debian-m68k-cross
1382 container_cross_prefix=m68k-linux-gnu-
1383 ;;
1384 microblaze)
1385 container_image=debian-microblaze-cross
1386 container_cross_prefix=microblaze-linux-musl-
1387 ;;
1388 mips64el)
1389 container_image=debian-mips64el-cross
1390 container_cross_prefix=mips64el-linux-gnuabi64-
1391 ;;
1392 mips64)
1393 container_image=debian-mips64-cross
1394 container_cross_prefix=mips64-linux-gnuabi64-
1395 ;;
1396 mipsel)
1397 container_image=debian-mipsel-cross
1398 container_cross_prefix=mipsel-linux-gnu-
1399 ;;
1400 mips)
1401 container_image=debian-mips-cross
1402 container_cross_prefix=mips-linux-gnu-
1403 ;;
1404 nios2)
1405 container_image=debian-nios2-cross
1406 container_cross_prefix=nios2-linux-gnu-
1407 ;;
1408 ppc)
1409 container_image=debian-powerpc-test-cross
1410 container_cross_prefix=powerpc-linux-gnu-
1411 container_cross_cc=${container_cross_prefix}gcc-10
1412 ;;
1413 ppc64|ppc64le)
1414 container_image=debian-powerpc-test-cross
1415 container_cross_prefix=powerpc${target_arch#ppc}-linux-gnu-
1416 container_cross_cc=${container_cross_prefix}gcc-10
1417 ;;
1418 riscv64)
1419 container_image=debian-riscv64-test-cross
1420 container_cross_prefix=riscv64-linux-gnu-
1421 ;;
1422 s390x)
1423 container_image=debian-s390x-cross
1424 container_cross_prefix=s390x-linux-gnu-
1425 ;;
1426 sh4)
1427 container_image=debian-sh4-cross
1428 container_cross_prefix=sh4-linux-gnu-
1429 ;;
1430 sparc64)
1431 container_image=debian-sparc64-cross
1432 container_cross_prefix=sparc64-linux-gnu-
1433 ;;
1434 tricore)
1435 container_image=debian-tricore-cross
1436 container_cross_prefix=tricore-
1437 container_cross_as=tricore-as
1438 container_cross_ld=tricore-ld
1439 break
1440 ;;
1441 x86_64)
1442 container_image=debian-amd64-cross
1443 container_cross_prefix=x86_64-linux-gnu-
1444 ;;
1445 xtensa*)
1446 container_hosts=x86_64
1447 container_image=debian-xtensa-cross
1448
1449 # default to the dc232b cpu
1450 container_cross_prefix=/opt/2020.07/xtensa-dc232b-elf/bin/xtensa-dc232b-elf-
1451 ;;
1452 esac
1453 : ${container_cross_cc:=${container_cross_prefix}gcc}
1454 : ${container_cross_ar:=${container_cross_prefix}ar}
1455 : ${container_cross_as:=${container_cross_prefix}as}
1456 : ${container_cross_ld:=${container_cross_prefix}ld}
1457 : ${container_cross_nm:=${container_cross_prefix}nm}
1458 : ${container_cross_objcopy:=${container_cross_prefix}objcopy}
1459 : ${container_cross_ranlib:=${container_cross_prefix}ranlib}
1460 : ${container_cross_strip:=${container_cross_prefix}strip}
1461 done
1462
1463 try=cross
1464 case "$target_arch:$cpu" in
1465 aarch64_be:aarch64 | \
1466 armeb:arm | \
1467 i386:x86_64 | \
1468 mips*:mips64 | \
1469 ppc*:ppc64 | \
1470 sparc:sparc64 | \
1471 "$cpu:$cpu")
1472 try='native cross' ;;
1473 esac
1474 eval "target_cflags=\${cross_cc_cflags_$target_arch}"
1475 for thistry in $try; do
1476 case $thistry in
1477 native)
1478 target_cc=$cc
1479 target_ccas=$ccas
1480 target_ar=$ar
1481 target_as=$as
1482 target_ld=$ld
1483 target_nm=$nm
1484 target_objcopy=$objcopy
1485 target_ranlib=$ranlib
1486 target_strip=$strip
1487 ;;
1488 cross)
1489 target_cc=
1490 if eval test -n "\"\${cross_cc_$target_arch}\""; then
1491 if eval has "\"\${cross_cc_$target_arch}\""; then
1492 eval "target_cc=\"\${cross_cc_$target_arch}\""
1493 fi
1494 else
1495 compute_target_variable $target_arch target_cc gcc
1496 fi
1497 target_ccas=$target_cc
1498 compute_target_variable $target_arch target_ar ar
1499 compute_target_variable $target_arch target_as as
1500 compute_target_variable $target_arch target_ld ld
1501 compute_target_variable $target_arch target_nm nm
1502 compute_target_variable $target_arch target_objcopy objcopy
1503 compute_target_variable $target_arch target_ranlib ranlib
1504 compute_target_variable $target_arch target_strip strip
1505 ;;
1506 esac
1507
1508 if test -n "$target_cc"; then
1509 case $target_arch in
1510 i386|x86_64)
1511 if $target_cc --version | grep -qi "clang"; then
1512 continue
1513 fi
1514 ;;
1515 esac
1516 elif test -n "$target_as" && test -n "$target_ld"; then
1517 # Special handling for assembler only targets
1518 case $target in
1519 tricore-softmmu)
1520 build_static=
1521 got_cross_cc=yes
1522 break
1523 ;;
1524 *)
1525 continue
1526 ;;
1527 esac
1528 else
1529 continue
1530 fi
1531
1532 write_c_skeleton
1533 case $1 in
1534 *-softmmu)
1535 if do_compiler "$target_cc" $target_cflags -o $TMPO -c $TMPC &&
1536 do_compiler "$target_cc" $target_cflags -r -nostdlib -o "${TMPDIR1}/${TMPB}2.o" "$TMPO" -lgcc; then
1537 got_cross_cc=yes
1538 break
1539 fi
1540 ;;
1541 *)
1542 if do_compiler "$target_cc" $target_cflags -o $TMPE $TMPC -static ; then
1543 build_static=y
1544 got_cross_cc=yes
1545 break
1546 fi
1547 if do_compiler "$target_cc" $target_cflags -o $TMPE $TMPC ; then
1548 build_static=
1549 got_cross_cc=yes
1550 break
1551 fi
1552 ;;
1553 esac
1554 done
1555 if test $got_cross_cc != yes; then
1556 build_static=
1557 target_cc=
1558 target_ccas=
1559 target_ar=
1560 target_as=
1561 target_ld=
1562 target_nm=
1563 target_objcopy=
1564 target_ranlib=
1565 target_strip=
1566 fi
1567 test -n "$target_cc"
1568 }
1569
1570 write_target_makefile() {
1571 echo "EXTRA_CFLAGS=$target_cflags"
1572 if test -z "$target_cc" && test -z "$target_as"; then
1573 test -z "$container_image" && error_exit "Internal error: could not find cross compiler for $1?"
1574 echo "$1: docker-image-$container_image" >> Makefile.prereqs
1575 if test -n "$container_cross_cc"; then
1576 echo "CC=$docker_py cc --cc $container_cross_cc -i qemu/$container_image -s $source_path --"
1577 echo "CCAS=$docker_py cc --cc $container_cross_cc -i qemu/$container_image -s $source_path --"
1578 fi
1579 echo "AR=$docker_py cc --cc $container_cross_ar -i qemu/$container_image -s $source_path --"
1580 echo "AS=$docker_py cc --cc $container_cross_as -i qemu/$container_image -s $source_path --"
1581 echo "LD=$docker_py cc --cc $container_cross_ld -i qemu/$container_image -s $source_path --"
1582 echo "NM=$docker_py cc --cc $container_cross_nm -i qemu/$container_image -s $source_path --"
1583 echo "OBJCOPY=$docker_py cc --cc $container_cross_objcopy -i qemu/$container_image -s $source_path --"
1584 echo "RANLIB=$docker_py cc --cc $container_cross_ranlib -i qemu/$container_image -s $source_path --"
1585 echo "STRIP=$docker_py cc --cc $container_cross_strip -i qemu/$container_image -s $source_path --"
1586 else
1587 if test -n "$target_cc"; then
1588 echo "CC=$target_cc"
1589 echo "CCAS=$target_ccas"
1590 fi
1591 if test -n "$target_ar"; then
1592 echo "AR=$target_ar"
1593 fi
1594 if test -n "$target_as"; then
1595 echo "AS=$target_as"
1596 fi
1597 if test -n "$target_ld"; then
1598 echo "LD=$target_ld"
1599 fi
1600 if test -n "$target_nm"; then
1601 echo "NM=$target_nm"
1602 fi
1603 if test -n "$target_objcopy"; then
1604 echo "OBJCOPY=$target_objcopy"
1605 fi
1606 if test -n "$target_ranlib"; then
1607 echo "RANLIB=$target_ranlib"
1608 fi
1609 if test -n "$target_strip"; then
1610 echo "STRIP=$target_strip"
1611 fi
1612 fi
1613 }
1614
1615 ##########################################
1616 # check for vfio_user_server
1617
1618 case "$vfio_user_server" in
1619 enabled )
1620 if test "$git_submodules_action" != "ignore"; then
1621 git_submodules="${git_submodules} subprojects/libvfio-user"
1622 fi
1623 ;;
1624 esac
1625
1626 #######################################
1627 # cross-compiled firmware targets
1628
1629 # Set up build tree symlinks that point back into the source tree
1630 # (these can be both files and directories).
1631 # Caution: avoid adding files or directories here using wildcards. This
1632 # will result in problems later if a new file matching the wildcard is
1633 # added to the source tree -- nothing will cause configure to be rerun
1634 # so the build tree will be missing the link back to the new file, and
1635 # tests might fail. Prefer to keep the relevant files in their own
1636 # directory and symlink the directory instead.
1637 LINKS="Makefile"
1638 LINKS="$LINKS docs/config"
1639 LINKS="$LINKS pc-bios/optionrom/Makefile"
1640 LINKS="$LINKS pc-bios/s390-ccw/Makefile"
1641 LINKS="$LINKS pc-bios/vof/Makefile"
1642 LINKS="$LINKS .gdbinit scripts" # scripts needed by relative path in .gdbinit
1643 LINKS="$LINKS tests/avocado tests/data"
1644 LINKS="$LINKS tests/qemu-iotests/check"
1645 LINKS="$LINKS python"
1646 LINKS="$LINKS contrib/plugins/Makefile "
1647 for f in $LINKS ; do
1648 if [ -e "$source_path/$f" ]; then
1649 symlink "$source_path/$f" "$f"
1650 fi
1651 done
1652
1653 echo "# Automatically generated by configure - do not modify" > Makefile.prereqs
1654
1655 # Mac OS X ships with a broken assembler
1656 roms=
1657 if have_target i386-softmmu x86_64-softmmu && \
1658 test "$targetos" != "darwin" && test "$targetos" != "sunos" && \
1659 test "$targetos" != "haiku" && \
1660 probe_target_compiler i386-softmmu; then
1661 roms="pc-bios/optionrom"
1662 config_mak=pc-bios/optionrom/config.mak
1663 echo "# Automatically generated by configure - do not modify" > $config_mak
1664 echo "TOPSRC_DIR=$source_path" >> $config_mak
1665 write_target_makefile >> $config_mak
1666 fi
1667
1668 if have_target ppc-softmmu ppc64-softmmu && \
1669 probe_target_compiler ppc-softmmu; then
1670 roms="$roms pc-bios/vof"
1671 config_mak=pc-bios/vof/config.mak
1672 echo "# Automatically generated by configure - do not modify" > $config_mak
1673 echo "SRC_DIR=$source_path/pc-bios/vof" >> $config_mak
1674 write_target_makefile >> $config_mak
1675 fi
1676
1677 # Only build s390-ccw bios if the compiler has -march=z900 or -march=z10
1678 # (which is the lowest architecture level that Clang supports)
1679 if have_target s390x-softmmu && probe_target_compiler s390x-softmmu; then
1680 write_c_skeleton
1681 do_compiler "$target_cc" $target_cc_cflags -march=z900 -o $TMPO -c $TMPC
1682 has_z900=$?
1683 if [ $has_z900 = 0 ] || do_compiler "$target_cc" $target_cc_cflags -march=z10 -msoft-float -Werror -o $TMPO -c $TMPC; then
1684 if [ $has_z900 != 0 ]; then
1685 echo "WARNING: Your compiler does not support the z900!"
1686 echo " The s390-ccw bios will only work with guest CPUs >= z10."
1687 fi
1688 roms="$roms pc-bios/s390-ccw"
1689 config_mak=pc-bios/s390-ccw/config-host.mak
1690 echo "# Automatically generated by configure - do not modify" > $config_mak
1691 echo "SRC_PATH=$source_path/pc-bios/s390-ccw" >> $config_mak
1692 write_target_makefile >> $config_mak
1693 # SLOF is required for building the s390-ccw firmware on s390x,
1694 # since it is using the libnet code from SLOF for network booting.
1695 git_submodules="${git_submodules} roms/SLOF"
1696 fi
1697 fi
1698
1699 #######################################
1700 # generate config-host.mak
1701
1702 if ! (GIT="$git" "$source_path/scripts/git-submodule.sh" "$git_submodules_action" "$git_submodules"); then
1703 exit 1
1704 fi
1705
1706 config_host_mak="config-host.mak"
1707
1708 echo "# Automatically generated by configure - do not modify" > $config_host_mak
1709 echo >> $config_host_mak
1710
1711 echo all: >> $config_host_mak
1712 echo "GIT=$git" >> $config_host_mak
1713 echo "GIT_SUBMODULES=$git_submodules" >> $config_host_mak
1714 echo "GIT_SUBMODULES_ACTION=$git_submodules_action" >> $config_host_mak
1715
1716 if test "$debug_tcg" = "yes" ; then
1717 echo "CONFIG_DEBUG_TCG=y" >> $config_host_mak
1718 fi
1719 if test "$mingw32" = "yes" ; then
1720 echo "CONFIG_WIN32=y" >> $config_host_mak
1721 echo "QEMU_GA_MANUFACTURER=${QEMU_GA_MANUFACTURER-QEMU}" >> $config_host_mak
1722 echo "QEMU_GA_DISTRO=${QEMU_GA_DISTRO-Linux}" >> $config_host_mak
1723 echo "QEMU_GA_VERSION=${QEMU_GA_VERSION-$(cat "$source_path"/VERSION)}" >> $config_host_mak
1724 else
1725 echo "CONFIG_POSIX=y" >> $config_host_mak
1726 fi
1727
1728 if test "$linux" = "yes" ; then
1729 echo "CONFIG_LINUX=y" >> $config_host_mak
1730 fi
1731
1732 if test "$darwin" = "yes" ; then
1733 echo "CONFIG_DARWIN=y" >> $config_host_mak
1734 fi
1735
1736 if test "$solaris" = "yes" ; then
1737 echo "CONFIG_SOLARIS=y" >> $config_host_mak
1738 fi
1739 echo "SRC_PATH=$source_path" >> $config_host_mak
1740 echo "TARGET_DIRS=$target_list" >> $config_host_mak
1741
1742 # XXX: suppress that
1743 if [ "$bsd" = "yes" ] ; then
1744 echo "CONFIG_BSD=y" >> $config_host_mak
1745 fi
1746
1747 if test "$plugins" = "yes" ; then
1748 echo "CONFIG_PLUGIN=y" >> $config_host_mak
1749 fi
1750
1751 if test -n "$gdb_bin"; then
1752 gdb_version=$($gdb_bin --version | head -n 1)
1753 if version_ge ${gdb_version##* } 9.1; then
1754 echo "HAVE_GDB_BIN=$gdb_bin" >> $config_host_mak
1755 gdb_arches=$($python "$source_path/scripts/probe-gdb-support.py" $gdb_bin)
1756 else
1757 gdb_bin=""
1758 fi
1759 fi
1760
1761 if test "$container" != no; then
1762 echo "ENGINE=$container" >> $config_host_mak
1763 echo "RUNC=$runc" >> $config_host_mak
1764 fi
1765 echo "ROMS=$roms" >> $config_host_mak
1766 echo "PYTHON=$python" >> $config_host_mak
1767 echo "GENISOIMAGE=$genisoimage" >> $config_host_mak
1768 echo "MESON=$meson" >> $config_host_mak
1769 echo "NINJA=$ninja" >> $config_host_mak
1770 echo "PKG_CONFIG=${pkg_config}" >> $config_host_mak
1771 echo "CC=$cc" >> $config_host_mak
1772 echo "EXESUF=$EXESUF" >> $config_host_mak
1773
1774 # use included Linux headers
1775 if test "$linux" = "yes" ; then
1776 mkdir -p linux-headers
1777 case "$cpu" in
1778 i386|x86_64)
1779 linux_arch=x86
1780 ;;
1781 ppc|ppc64)
1782 linux_arch=powerpc
1783 ;;
1784 s390x)
1785 linux_arch=s390
1786 ;;
1787 aarch64)
1788 linux_arch=arm64
1789 ;;
1790 loongarch*)
1791 linux_arch=loongarch
1792 ;;
1793 mips64)
1794 linux_arch=mips
1795 ;;
1796 *)
1797 # For most CPUs the kernel architecture name and QEMU CPU name match.
1798 linux_arch="$cpu"
1799 ;;
1800 esac
1801 # For non-KVM architectures we will not have asm headers
1802 if [ -e "$source_path/linux-headers/asm-$linux_arch" ]; then
1803 symlink "$source_path/linux-headers/asm-$linux_arch" linux-headers/asm
1804 fi
1805 fi
1806
1807 for target in $target_list; do
1808 target_dir="$target"
1809 target_name=$(echo $target | cut -d '-' -f 1)$EXESUF
1810 mkdir -p "$target_dir"
1811 case $target in
1812 *-user) symlink "../qemu-$target_name" "$target_dir/qemu-$target_name" ;;
1813 *) symlink "../qemu-system-$target_name" "$target_dir/qemu-system-$target_name" ;;
1814 esac
1815 done
1816
1817 if test "$default_targets" = "yes"; then
1818 echo "CONFIG_DEFAULT_TARGETS=y" >> $config_host_mak
1819 fi
1820
1821 if test "$ccache_cpp2" = "yes"; then
1822 echo "export CCACHE_CPP2=y" >> $config_host_mak
1823 fi
1824
1825 # tests/tcg configuration
1826 (config_host_mak=tests/tcg/config-host.mak
1827 mkdir -p tests/tcg
1828 echo "# Automatically generated by configure - do not modify" > $config_host_mak
1829 echo "SRC_PATH=$source_path" >> $config_host_mak
1830 echo "HOST_CC=$host_cc" >> $config_host_mak
1831
1832 # versioned checked in the main config_host.mak above
1833 if test -n "$gdb_bin"; then
1834 echo "HAVE_GDB_BIN=$gdb_bin" >> $config_host_mak
1835 fi
1836 if test "$plugins" = "yes" ; then
1837 echo "CONFIG_PLUGIN=y" >> $config_host_mak
1838 fi
1839
1840 tcg_tests_targets=
1841 for target in $target_list; do
1842 arch=${target%%-*}
1843
1844 case $target in
1845 xtensa*-linux-user)
1846 # the toolchain is not complete with headers, only build softmmu tests
1847 continue
1848 ;;
1849 *-softmmu)
1850 test -f "$source_path/tests/tcg/$arch/Makefile.softmmu-target" || continue
1851 qemu="qemu-system-$arch"
1852 ;;
1853 *-linux-user|*-bsd-user)
1854 qemu="qemu-$arch"
1855 ;;
1856 esac
1857
1858 if probe_target_compiler $target || test -n "$container_image"; then
1859 test -n "$container_image" && build_static=y
1860 mkdir -p "tests/tcg/$target"
1861 config_target_mak=tests/tcg/$target/config-target.mak
1862 ln -sf "$source_path/tests/tcg/Makefile.target" "tests/tcg/$target/Makefile"
1863 echo "# Automatically generated by configure - do not modify" > "$config_target_mak"
1864 echo "TARGET_NAME=$arch" >> "$config_target_mak"
1865 echo "TARGET=$target" >> "$config_target_mak"
1866 write_target_makefile "build-tcg-tests-$target" >> "$config_target_mak"
1867 echo "BUILD_STATIC=$build_static" >> "$config_target_mak"
1868 echo "QEMU=$PWD/$qemu" >> "$config_target_mak"
1869
1870 # will GDB work with these binaries?
1871 if test "${gdb_arches#*$arch}" != "$gdb_arches"; then
1872 echo "HOST_GDB_SUPPORTS_ARCH=y" >> "$config_target_mak"
1873 fi
1874
1875 echo "run-tcg-tests-$target: $qemu\$(EXESUF)" >> Makefile.prereqs
1876 tcg_tests_targets="$tcg_tests_targets $target"
1877 fi
1878 done
1879
1880 if test "$tcg" = "enabled"; then
1881 echo "TCG_TESTS_TARGETS=$tcg_tests_targets" >> config-host.mak
1882 fi
1883 )
1884
1885 if test "$skip_meson" = no; then
1886 cross="config-meson.cross.new"
1887 meson_quote() {
1888 test $# = 0 && return
1889 echo "'$(echo $* | sed "s/ /','/g")'"
1890 }
1891
1892 echo "# Automatically generated by configure - do not modify" > $cross
1893 echo "[properties]" >> $cross
1894
1895 # unroll any custom device configs
1896 for a in $device_archs; do
1897 eval "c=\$devices_${a}"
1898 echo "${a}-softmmu = '$c'" >> $cross
1899 done
1900
1901 echo "[built-in options]" >> $cross
1902 echo "c_args = [$(meson_quote $CFLAGS $EXTRA_CFLAGS)]" >> $cross
1903 echo "cpp_args = [$(meson_quote $CXXFLAGS $EXTRA_CXXFLAGS)]" >> $cross
1904 test -n "$objcc" && echo "objc_args = [$(meson_quote $OBJCFLAGS $EXTRA_OBJCFLAGS)]" >> $cross
1905 echo "c_link_args = [$(meson_quote $CFLAGS $LDFLAGS $EXTRA_CFLAGS $EXTRA_LDFLAGS)]" >> $cross
1906 echo "cpp_link_args = [$(meson_quote $CXXFLAGS $LDFLAGS $EXTRA_CXXFLAGS $EXTRA_LDFLAGS)]" >> $cross
1907 echo "[binaries]" >> $cross
1908 echo "c = [$(meson_quote $cc $CPU_CFLAGS)]" >> $cross
1909 test -n "$cxx" && echo "cpp = [$(meson_quote $cxx $CPU_CFLAGS)]" >> $cross
1910 test -n "$objcc" && echo "objc = [$(meson_quote $objcc $CPU_CFLAGS)]" >> $cross
1911 echo "ar = [$(meson_quote $ar)]" >> $cross
1912 echo "nm = [$(meson_quote $nm)]" >> $cross
1913 echo "pkgconfig = [$(meson_quote $pkg_config)]" >> $cross
1914 echo "ranlib = [$(meson_quote $ranlib)]" >> $cross
1915 if has $sdl2_config; then
1916 echo "sdl2-config = [$(meson_quote $sdl2_config)]" >> $cross
1917 fi
1918 echo "strip = [$(meson_quote $strip)]" >> $cross
1919 echo "widl = [$(meson_quote $widl)]" >> $cross
1920 echo "windres = [$(meson_quote $windres)]" >> $cross
1921 echo "windmc = [$(meson_quote $windmc)]" >> $cross
1922 if test "$cross_compile" = "yes"; then
1923 cross_arg="--cross-file config-meson.cross"
1924 echo "[host_machine]" >> $cross
1925 echo "system = '$targetos'" >> $cross
1926 case "$cpu" in
1927 i386)
1928 echo "cpu_family = 'x86'" >> $cross
1929 ;;
1930 *)
1931 echo "cpu_family = '$cpu'" >> $cross
1932 ;;
1933 esac
1934 echo "cpu = '$cpu'" >> $cross
1935 if test "$bigendian" = "yes" ; then
1936 echo "endian = 'big'" >> $cross
1937 else
1938 echo "endian = 'little'" >> $cross
1939 fi
1940 else
1941 cross_arg="--native-file config-meson.cross"
1942 fi
1943 mv $cross config-meson.cross
1944
1945 rm -rf meson-private meson-info meson-logs
1946
1947 # Prevent meson from automatically downloading wrapped subprojects when missing.
1948 # You can use 'meson subprojects download' before running configure.
1949 meson_option_add "--wrap-mode=nodownload"
1950
1951 # Built-in options
1952 test "$bindir" != "bin" && meson_option_add "-Dbindir=$bindir"
1953 test "$default_feature" = no && meson_option_add -Dauto_features=disabled
1954 test "$static" = yes && meson_option_add -Dprefer_static=true
1955 test "$pie" = no && meson_option_add -Db_pie=false
1956 test "$werror" = yes && meson_option_add -Dwerror=true
1957
1958 # QEMU options
1959 test "$cfi" != false && meson_option_add "-Dcfi=$cfi"
1960 test "$docs" != auto && meson_option_add "-Ddocs=$docs"
1961 test "$fdt" != auto && meson_option_add "-Dfdt=$fdt"
1962 test -n "${LIB_FUZZING_ENGINE+xxx}" && meson_option_add "-Dfuzzing_engine=$LIB_FUZZING_ENGINE"
1963 test "$qemu_suffix" != qemu && meson_option_add "-Dqemu_suffix=$qemu_suffix"
1964 test "$smbd" != '' && meson_option_add "-Dsmbd=$smbd"
1965 test "$tcg" != enabled && meson_option_add "-Dtcg=$tcg"
1966 test "$vfio_user_server" != auto && meson_option_add "-Dvfio_user_server=$vfio_user_server"
1967 run_meson() {
1968 NINJA=$ninja $meson setup --prefix "$prefix" "$@" $cross_arg "$PWD" "$source_path"
1969 }
1970 eval run_meson $meson_options
1971 if test "$?" -ne 0 ; then
1972 error_exit "meson setup failed"
1973 fi
1974 else
1975 if test -f meson-private/cmd_line.txt; then
1976 # Adjust old command line options that were removed
1977 # sed -i is not portable
1978 perl -i -ne '
1979 /^sphinx_build/ && next;
1980 print;' meson-private/cmd_line.txt
1981 fi
1982 fi
1983
1984 # Save the configure command line for later reuse.
1985 cat <<EOD >config.status
1986 #!/bin/sh
1987 # Generated by configure.
1988 # Run this file to recreate the current configuration.
1989 # Compiler output produced by configure, useful for debugging
1990 # configure, is in config.log if it exists.
1991 EOD
1992
1993 preserve_env() {
1994 envname=$1
1995
1996 eval envval=\$$envname
1997
1998 if test -n "$envval"
1999 then
2000 echo "$envname='$envval'" >> config.status
2001 echo "export $envname" >> config.status
2002 else
2003 echo "unset $envname" >> config.status
2004 fi
2005 }
2006
2007 # Preserve various env variables that influence what
2008 # features/build target configure will detect
2009 preserve_env AR
2010 preserve_env AS
2011 preserve_env CC
2012 preserve_env CFLAGS
2013 preserve_env CXX
2014 preserve_env CXXFLAGS
2015 preserve_env LD
2016 preserve_env LDFLAGS
2017 preserve_env LD_LIBRARY_PATH
2018 preserve_env NM
2019 preserve_env OBJCFLAGS
2020 preserve_env OBJCOPY
2021 preserve_env PATH
2022 preserve_env PKG_CONFIG
2023 preserve_env PKG_CONFIG_LIBDIR
2024 preserve_env PKG_CONFIG_PATH
2025 preserve_env PYTHON
2026 preserve_env QEMU_GA_MANUFACTURER
2027 preserve_env QEMU_GA_DISTRO
2028 preserve_env QEMU_GA_VERSION
2029 preserve_env SDL2_CONFIG
2030 preserve_env SMBD
2031 preserve_env STRIP
2032 preserve_env WIDL
2033 preserve_env WINDRES
2034 preserve_env WINDMC
2035
2036 printf "exec" >>config.status
2037 for i in "$0" "$@"; do
2038 test "$i" = --skip-meson || printf " %s" "$(quote_sh "$i")" >>config.status
2039 done
2040 echo ' "$@"' >>config.status
2041 chmod +x config.status
2042
2043 rm -r "$TMPDIR1"